# ZIAPI Documentation

Welcome to the main documentation page of the **ZIAPI**. The **ZIAPI** is a set of interfaces and concrete implementations to help you manage module implementation for the Zia project.

This document lists all the documentation pages for the API separated by category.

## General Documentation

General documentation pages will help you understand the general concepts of the ZIAPI better.

- [Getting started](general/GETTING_STARTED.md)
- [Why choose ZIAPI](general/WHY_US.md)
- [Modules](general/MODULES.md)
- [Contributing](general/CONTRIBUTING.md)

## Guides

Guides are step by step instructions on how to do pretty much anything with the ZIAPI.

- [Install and build](guides/INSTALL_AND_BUILD.md)
- [Module 101](guides/MODULES_101.md)
- [Implementing a handler module](guides/IMPLEMENT_HANDLER.md)
- [Implementing a pre-processor module](guides/IMPLEMENT_PREPROCESSOR.md)
- [Implementing a post-processor module](guides/IMPLEMENT_POSTPROCESSOR.md)
- [Implementing a network module](guides/IMPLEMENT_NETWORK.md)

## Module Examples

Module examples are code tutorials on how to build a variety of modules.

- [Logger Module Tutorial](examples/LOGGER.md)
- [Directory Listing Module Tutorial](examples/DIRECTORY_LISTING.md)
